=== debian/changelog ===
aws-crt-python (0.20.4+dfsg-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:33:50 +1100

aws-crt-python (0.20.4+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 17:25:59 +0000

aws-crt-python (0.20.4+dfsg-1) unstable; urgency=medium

  * New upstream version 0.20.4
  * d/copyright: drop references to upstream files that no longer exist

 -- Noah Meyerhans <noahm@debian.org>  Thu, 22 Feb 2024 15:38:29 -0800

aws-crt-python (0.20.2+dfsg-1) unstable; urgency=medium

  * add debian/update-source.sh
  * New upstream version 0.20.2

 -- Noah Meyerhans <noahm@debian.org>  Thu, 11 Jan 2024 20:06:09 -0800

aws-crt-python (0.19.19+dfsg-1) unstable; urgency=medium

  * New upstream version 0.19.19

 -- Noah Meyerhans <noahm@debian.org>  Thu, 07 Dec 2023 17:20:15 -0800
