=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%,\
      dversionmangle=s/\+dfsg//, oversionmangle=s/(.*)/$1+dfsg1/" \
   https://github.com/awslabs/aws-crt-python/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
